﻿/* SVG-Viewer Framework - define Namespace */

function getPage(event) {
	
    //when on mobile safari, the coordinates information is inside the targetTouches object
    if (event.targetTouches)
        event = event.targetTouches[0];
    if (event.pageX != null && event.pageY != null)

        return {
            pageX : event.pageX,
            pageY : event.pageY
        };
    var element = (!document.compatMode || document.compatMode == 'CSS1Compat') ? document.documentElement : document.body;
    
    return {
        pageX : event.clientX + element.scrollLeft,
        pageY : event.clientY + element.scrollTop
    };
}


/* CustomHostAdapter *///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function CustomHostAdapter(){
	this.name = "MobileHostAdapter";
	
	this.cached_colors = [];
	this.cached_legend = [];
	this.cached_texts = [];
	
	SvgViewerLib.SvgViewerRegistryInstance.m_currentHostAdapter = this;
}
 
CustomHostAdapter.prototype = {
	showSvg:function(url, container, enableMode, customSVGData) {
	
		this.cached_colors = [];	
		this.cached_legend = [];
		this.cached_texts = [];
	
		SvgViewerLib.SvgViewerRegistryInstance.getCurrentPitSvgViewerAdapter().showSvg(url, container, enableMode, customSVGData);
	},
	colorElements:function(requesturl) {
	
		var ids = [];
		var colors = [];

		if(!this.cached_colors['colors'] || this.cached_colors['colors'].length < 1){
			$.ajax({
	  			dataType: "json",
  				url: requesturl,
  				async: false, 
  				success: function(data) {
	  				$.each( data.elements, function( key, val) {
						ids.push(val.id);
  						colors.push(val.color);
  					});
				}
			});
			this.cached_colors['ids'] = ids;
			this.cached_colors['colors'] = colors;
		} else {
			colors = this.cached_colors['colors']; 
			ids = this.cached_colors['ids']; 
		}
		
		SvgViewerLib.SvgViewerRegistryInstance.getCurrentPitSvgViewerAdapter().colorElements(ids, colors);
	}, 
	insertColoringLegend:function(requesturl, name, scale, style) {
		var colors = [];
		var captions = [];

		if(!this.cached_legend['colors'] || this.cached_legend['colors'].length < 1){
			$.ajax({
	  			dataType: "json",
  				url: requesturl,
  				async: false, 
  				success: function(data) {
	  				$.each( data.legend, function( key, val) {
  						colors.push(val.color);
  						captions.push(val.caption);
  					});
				}
			});
			this.cached_legend['captions'] = captions;
			this.cached_legend['colors'] = colors;
		} else {
			colors = this.cached_legend['colors']; 
			captions = this.cached_legend['captions']; 
		}

		SvgViewerLib.SvgViewerRegistryInstance.getCurrentPitSvgViewerAdapter().insertColoringLegend( name, captions, colors, 0.8, 'Arial');
	}, 
	insertTexts:function(requesturl) {
		var ids = [];
		var texts = [];			
		var scale = [];
		var xy = [];
		

		if(!this.cached_texts['ids'] || this.cached_texts['ids'].length < 1){

			$.ajax({
		  		dataType: "json",
  				url: requesturl,
  				async: false, 
  				success: function(data) {
		  			$.each( data.texts, function( key, val) {
						ids.push(val.id);
  						texts.push(val.caption);
  						scale.push(val.scale);
  						var t = [];
  						t['x'] = val.x;
  						t['y'] = val.y;
  						xy.push(t);
  					});
				}
			});
			this.cached_texts['ids'] = ids;
			this.cached_texts['texts'] = texts;
			this.cached_texts['scale'] = scale;
			this.cached_texts['xy'] = xy;
		} else {
			ids = this.cached_texts['ids'];
			texts = this.cached_texts['texts'];
			scale = this.cached_texts['scale'];
			xy = this.cached_texts['xy'];
		}

		SvgViewerLib.SvgViewerRegistryInstance.getCurrentPitSvgViewerAdapter().insertTexts( ids, texts, scale, xy, 'Arial');		
	}, 
	
	showObjectsInHost:function(selected_elements) 
	{
		alert('called showObjectsInHost(' + selected_elements + ')');
	},
	
	/*
	getTooltipInfo:function(id) 
	{
		var url = '/tests/SVGViewer/data/' + $('input:radio[name=example]:checked').attr('rel') + '.json'; 
	
		var result = '';
		captions = [];
		$.ajax({
  			dataType: "json",
  			url: url,
  			async: false, 
  			success: function(data) {
  				$.each( data.tooltips, function( key, val) {
  					captions[val.id] = val.caption;
				});
			}
		});
		return captions[id];
	},
	*/
	
};
 

CustomHostAdapter.prototype = $.extend(
	{},
	SvgViewerLib.HostAdapter.prototype,
	CustomHostAdapter.prototype
);


/* CustomSvgViewerAdapter *///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function CustomSvgViewerAdapter(){
	this.name = "MobileSvgViewerAdapter";
	
	this.legendzoomlevel = 1;
	this.svgzoomlevel = 1;
	this.record = false;
	this.selected_elements = [];
	this.cached_tips = [];
	this.ContainerPlus = "";

	this.inScale = false;
	this.inDraw = false;
	this.inPin = false;

	this.currentDrawData = { drawing: false, currentDrawObject: null, mousePt: null, currentMousePt: null };

	this.svgLevel0 = null;
	this.rectSVG = null;
	this.rectViewer = null;

		
	this.clear_vars = function(){
		this.inScale = false;
		this.legendzoomlevel = 1;
		this.svgzoomlevel = 1;
		this.record = false;
		this.selected_elements = [];
		this.cached_tips = [];
	};
		
	SvgViewerLib.SvgViewerRegistryInstance.addPitSvgViewerAdapter(this,this.name);
}
 


CustomSvgViewerAdapter.prototype = {



	initDraw:function(e){
		
		custom_vieweradapter.currentDrawData.mousePt = custom_vieweradapter.svgLevel0.createSVGPoint(); // create the point
		custom_vieweradapter.currentDrawData.currentMousePt = custom_vieweradapter.svgLevel0.createSVGPoint(); // create the point

		var viewer = $("#viewer");
		var viewerRect = viewer[0].getBoundingClientRect();
		
		var page = getPage(e);
		
		custom_vieweradapter.currentDrawData.screenOffsetX = viewerRect.left;
		custom_vieweradapter.currentDrawData.screenOffsetY = viewerRect.top;
		
		var mouseX = page.pageX - custom_vieweradapter.currentDrawData.screenOffsetX;
		var mouseY = page.pageY - custom_vieweradapter.currentDrawData.screenOffsetY;
		
		
		var matrix = custom_vieweradapter.svgLevel0.getCTM();
		if(matrix){
			custom_vieweradapter.currentDrawData.svgMatrix = matrix.inverse();
		}
		else{
			custom_vieweradapter.currentDrawData.svgMatrix = custom_vieweradapter.svgLevel0.getScreenCTM().inverse();
			custom_vieweradapter.currentDrawData.svgMatrix.e += custom_vieweradapter.currentDrawData.screenOffsetX * custom_vieweradapter.currentDrawData.svgMatrix.a;
			custom_vieweradapter.currentDrawData.svgMatrix.f += custom_vieweradapter.currentDrawData.screenOffsetY * custom_vieweradapter.currentDrawData.svgMatrix.a;
		}

		custom_vieweradapter.currentDrawData.rectViewer = { width: viewer.width(), height: viewer.height() };
		custom_vieweradapter.currentDrawData.viewerWidthHalf = custom_vieweradapter.currentDrawData.rectViewer.width * 0.5;
		custom_vieweradapter.currentDrawData.viewerHeightHalf = custom_vieweradapter.currentDrawData.rectViewer.height * 0.5;

		custom_vieweradapter.currentDrawData.dX = 0;
		custom_vieweradapter.currentDrawData.dY = 0;
		custom_vieweradapter.currentDrawData.scale = 1;


		if(custom_vieweradapter.currentDrawData.currentPanzoomMatrix){

			custom_vieweradapter.currentDrawData.dX = parseFloat(custom_vieweradapter.currentDrawData.currentPanzoomMatrix[4]);
			custom_vieweradapter.currentDrawData.dY = parseFloat(custom_vieweradapter.currentDrawData.currentPanzoomMatrix[5]);
			custom_vieweradapter.currentDrawData.scale = custom_vieweradapter.currentDrawData.currentPanzoomMatrix[0];
		}

		var x = (mouseX - custom_vieweradapter.currentDrawData.viewerWidthHalf) / custom_vieweradapter.currentDrawData.scale + custom_vieweradapter.currentDrawData.viewerWidthHalf - custom_vieweradapter.currentDrawData.dX / custom_vieweradapter.currentDrawData.scale;
		var y = (mouseY - custom_vieweradapter.currentDrawData.viewerHeightHalf) / custom_vieweradapter.currentDrawData.scale + custom_vieweradapter.currentDrawData.viewerHeightHalf - custom_vieweradapter.currentDrawData.dY / custom_vieweradapter.currentDrawData.scale;


		custom_vieweradapter.currentDrawData.mousePt.x = x;
		custom_vieweradapter.currentDrawData.mousePt.y = y;
		
		//var transformed = custom_vieweradapter.currentDrawData.mousePt.matrixTransform(custom_vieweradapter.currentDrawData.svgMatrix);
		custom_vieweradapter.currentDrawData.mousePt.x = custom_vieweradapter.currentDrawData.mousePt.x * custom_vieweradapter.currentDrawData.svgMatrix.a + custom_vieweradapter.currentDrawData.svgMatrix.e;
		custom_vieweradapter.currentDrawData.mousePt.y = custom_vieweradapter.currentDrawData.mousePt.y * custom_vieweradapter.currentDrawData.svgMatrix.a + custom_vieweradapter.currentDrawData.svgMatrix.f;

		//console.log(custom_vieweradapter.currentDrawData.mousePt.x + ', ' + custom_vieweradapter.currentDrawData.mousePt.y);
	},

	enableRecord:function(){
		custom_vieweradapter.record = true;
	},

	disableRecord:function(){
		custom_vieweradapter.record = false;
	},

	enableDraw:function(){
		
		//Ti.API.info('enableDraw');
		custom_vieweradapter.inDraw = true;
		
		$(document).on('touchstart', "[id=mysvg]" ,function(e){
		  			
            e.preventDefault();
            e.stopPropagation();
            custom_vieweradapter.initDraw(e);
		});

		$(document).on('touchmove', "[id=mysvg]" ,function(e){
  			
  			e.preventDefault();
            e.stopPropagation();
			if(!custom_vieweradapter.currentDrawData.mousePt){
				return;
			}
			
			var page = getPage(e);

			var mouseX = page.pageX - custom_vieweradapter.currentDrawData.screenOffsetX;
			var mouseY = page.pageY - custom_vieweradapter.currentDrawData.screenOffsetY;

			var x = (mouseX - custom_vieweradapter.currentDrawData.viewerWidthHalf) / custom_vieweradapter.currentDrawData.scale + custom_vieweradapter.currentDrawData.viewerWidthHalf - custom_vieweradapter.currentDrawData.dX / custom_vieweradapter.currentDrawData.scale;
			var y = (mouseY - custom_vieweradapter.currentDrawData.viewerHeightHalf) / custom_vieweradapter.currentDrawData.scale + custom_vieweradapter.currentDrawData.viewerHeightHalf - custom_vieweradapter.currentDrawData.dY / custom_vieweradapter.currentDrawData.scale;


			custom_vieweradapter.currentDrawData.currentMousePt.x = x;
			custom_vieweradapter.currentDrawData.currentMousePt.y = y;
			
			//var transformed = custom_vieweradapter.currentDrawData.mousePt.matrixTransform(custom_vieweradapter.currentDrawData.svgMatrix);
			custom_vieweradapter.currentDrawData.currentMousePt.x = custom_vieweradapter.currentDrawData.currentMousePt.x * custom_vieweradapter.currentDrawData.svgMatrix.a + custom_vieweradapter.currentDrawData.svgMatrix.e;
			custom_vieweradapter.currentDrawData.currentMousePt.y = custom_vieweradapter.currentDrawData.currentMousePt.y * custom_vieweradapter.currentDrawData.svgMatrix.a + custom_vieweradapter.currentDrawData.svgMatrix.f;
			


			if(!custom_vieweradapter.currentDrawData.drawing){

				if(Math.abs(custom_vieweradapter.currentDrawData.currentMousePt.x - custom_vieweradapter.currentDrawData.mousePt.x) > 2 || Math.abs(custom_vieweradapter.currentDrawData.currentMousePt.y - custom_vieweradapter.currentDrawData.mousePt.y) > 2){
					custom_vieweradapter.currentDrawData.drawing = true;
					
					var s2 = Snap('#custom_draw_group');
					custom_vieweradapter.currentDrawObject = s2.line(custom_vieweradapter.currentDrawData.mousePt.x,custom_vieweradapter.currentDrawData.mousePt.y, custom_vieweradapter.currentDrawData.currentMousePt.x,custom_vieweradapter.currentDrawData.currentMousePt.y);
					//custom_vieweradapter.currentDrawObject.attr({stroke: '#00ADEF', id:'ttt'});
					//custom_vieweradapter.currentDrawObject.attr('stroke-width','5px');
					custom_vieweradapter.currentDrawObject.attr('vector-effect','non-scaling-stroke');
					custom_vieweradapter.currentDrawObject.addClass('hasMenu');
					custom_vieweradapter.currentDrawObject.addClass('custom_draw_object');
				}

			}
			else{
				custom_vieweradapter.currentDrawObject.attr('x2',custom_vieweradapter.currentDrawData.currentMousePt.x);
				custom_vieweradapter.currentDrawObject.attr('y2',custom_vieweradapter.currentDrawData.currentMousePt.y);
			}
		});

		$(document).on('touchend', "[id=mysvg]" ,function(e){
			e.preventDefault();
            e.stopPropagation();

	  		custom_vieweradapter.currentDrawData.currentMousePt = null;
	  		custom_vieweradapter.currentDrawData.mousePt = null;
	  		custom_vieweradapter.currentDrawData.drawing = false;
	  		custom_vieweradapter.currentDrawObject = null;
		});
	},

	disableDraw : function(){
		
		//Ti.API.info('disableDraw');
		custom_vieweradapter.inDraw = false;
		$(document).off('touchstart', "[id=mysvg]");
		$(document).off('touchmove', "[id=mysvg]");
		$(document).off('touchend', "[id=mysvg]");
	},
	
	enablePin : function(){
		custom_vieweradapter.inPin = true;
		$(document).on('touchstart', "[id=mysvg]" ,function(e){

			e.preventDefault();
            e.stopPropagation();

			custom_vieweradapter.initDraw(e);
			var realBBox = custom_vieweradapter.svgLevel0.getBBox();
			var maxDim = Math.max(realBBox.width, realBBox.height);
			var imgSize = maxDim / 20;

			var endPosX = custom_vieweradapter.currentDrawData.mousePt.x+imgSize*0.5;
			var endPosY = custom_vieweradapter.currentDrawData.mousePt.y - imgSize;

			/*
			//check for gradientDefinition
			var gradDef = $('#pinGradient');
			if(!gradDef.length){
				var defs = $('#mysvg defs');
				defs.append('<radialGradient id="pinGradient" cx="50%" cy="50%" r="50%" fx="50%" fy="50%"><stop offset="0%" style="stop-color:rgb(255,255,255);stop-opacity:0" /><stop offset="100%" style="stop-color:rgb(0,0,255);stop-opacity:1" /></radialGradient>');
			}
			*/
			

			var s2 = Snap('#custom_draw_group');
			if(s2){
				var pinGroup = s2.g();
				pinGroup.addClass('custom_draw_object');
				var line = pinGroup.line(custom_vieweradapter.currentDrawData.mousePt.x,custom_vieweradapter.currentDrawData.mousePt.y, endPosX, endPosY);
				line.attr('vector-effect','non-scaling-stroke');
				line.attr('stroke', '#AAAAAA');
				line.attr('stroke-width','3px');
				
	
				var circle = pinGroup.circle(endPosX, endPosY, imgSize * 0.25);
				circle.attr('fill', 'red');
				circle.attr('stroke-width','0px');
				circle.addClass('pinCircle');
				circle.addClass('hasMenu');
				
				//custom_vieweradapter.currentDrawObject = s2.image('images/pin.png', custom_vieweradapter.currentDrawData.mousePt.x,custom_vieweradapter.currentDrawData.mousePt.y, imgSize, imgSize);
				custom_vieweradapter.currentDrawData.mousePt = null;		
			}
		});
	},

	disablePin : function(){
		custom_vieweradapter.inPin = false;
		$(document).off('touchstart', "[id=mysvg]");
	},
	

	enableZoom : function(){

		//Ti.API.info('enableZoom');
		var svg = $("#viewer").find('svg');
		if(svg.length){
			var panzoom = svg.panzoom({
	                //$zoomIn: $("[id=svgzoomin]"),
	                //$zoomOut: $("[id=svgzoomout]"),
	                //startTransform: undefined,
	                increment: 0.5,
	                minScale: 1.0,
	                contain: 'invert',
	                cursor: "move",
	            });//.panzoom('zoom');
	        custom_vieweradapter.inScale = true;
		}
		/*
		svg.on('touchstart', function(e){
				Ti.API.info('touchstart in zoom');
		});
		*/
	},

	disableZoom : function(){
		
		//Ti.API.info('disableZoom');
		var svg = $("#viewer").find('svg');
		if(svg.length){
			
			custom_vieweradapter.currentDrawData.currentPanzoomMatrix = svg.panzoom('getMatrix');
			var matrixString = custom_vieweradapter.currentDrawData.currentPanzoomMatrix.toString();

        	svg.panzoom('reset');
        	svg.panzoom('destroy');

			custom_vieweradapter.svgLevel0.style.transform = "matrix("+matrixString+")";

        	custom_vieweradapter.inScale = false;
        }
	},

	showSvg:function(url, container, enableMode, customSVGData) {
	
	
		this.ContainerPlus = "#" + container + "";
	
		//"Init" des Viewers
		//
		$(this.ContainerPlus).empty();
		this.clear_vars();	
		
		
		var result = '';
		$.ajax({
      		url: url,
      		dataType: 'text',
      		async: false,
      			success: function (data) {
        		localStorage.setItem('xml-content', data);
        		result = data;   
      		},
            statusCode: {
                404: function() {
                    alert( "Fehler 404: Die URL existiert nicht" );
      			}
            }
    	});
		
		var viewer = $("#viewer");
		viewer.width(window.innerWidth);
		viewer.height(window.innerHeight - 50);
		
		viewer.append('<div id="Canvas" style="background-Color:#FFF;width:100%;height:100%"></div>');
		
		//Parse SVG and append it to div
		var s = Snap("#Canvas");
		var parsed = Snap.parse(result);
		parsed.selectAll('polygon').attr({'pointer-events':"visible" });
		s.append(parsed);
		
		var svg = viewer.find('svg');
		
		if(svg.length > 0){
			
			svg.width("100%");
			svg.height("100%");
			svg.attr('id', 'mysvg');
			custom_vieweradapter.svgLevel0 = $('#mysvg')[0];
			
			var groupLoaded = false;
			var s2 = Snap('#mysvg');
			if(customSVGData){
				try{

					var customSVGDataObj = JSON.parse(customSVGData);
					var xotree = new UTIL.XML.ObjTree();
					var xmlCustomSVG = xotree.writeXML(customSVGDataObj);
					
			        var parsed = Snap.parse(xmlCustomSVG);
			        var g = parsed.select("g");
			        s2.append(g);
			        groupLoaded = true;		
				}
				catch(e){
					Ti.App.log('Error in parsing custom svg: ' + e.message);
				}
			}
			
			if(!groupLoaded){

				var drawGroup = s2.g();
				drawGroup.attr({stroke: '#00ADEF', id:'custom_draw_group'});
				drawGroup.attr('stroke-width','5px');
				drawGroup.attr('vector-effect','non-scaling-stroke');
			}
			
			if(enableMode){
				var enableFunction = 'enable' + enableMode;
				if(custom_vieweradapter[enableFunction]){
					custom_vieweradapter[enableFunction]();
					
					enableButton('bt' + enableMode);
				}
			}
			
			
			
			svg.on('touchstart', "path, polygon, circle" ,function(e){
		
				//var page = getPage(e);
				//Ti.API.info(page.pageX + ',' +  page.pageY);
		
				e.preventDefault();
			    //e.stopPropagation();
			
				if(!custom_vieweradapter.inPin){
					var clickedElem = $(this);
					
					var classString = clickedElem.attr('class');
					if(classString && classString.indexOf('pinCircle') >= 0){
							
						clickedElem.contextMenu();	
						return;
					}
				}
			
			
				if(custom_vieweradapter.record === true){
					
					custom_vieweradapter.selected_elements.push(this.id);
					$(this).attr( "fill", "#0F0");
					$(this).css("fill", "#0F0");
				}
			});

		}


		return result;
	},	
	
	onDelete : function(elem){

		var counter = 0;
		var currentElem = elem;
		var found = false;
		while(!found){
			if(counter > 3){
				return; //nicht endlos suchen
			}
			var classString = currentElem.attr("class");
			if(classString.indexOf('custom_draw_object') >= 0){
				found = true;
			}
			else{
				currentElem = currentElem.parent();
				if(!currentElem || !currentElem.length){
					currentElem = null;
					found = true;
				}
			}
			counter++;
		}
		if(currentElem){
			currentElem.remove();
		}
	},	
	
	colorElements:function(ids, colors) {
        
        // if no svg available - print it to console
        if($("html").find('svg').length == 0){
            //Ti.API.info('************************  C O L O R I N G  ************************');
			ids.forEach(function (value, index, ar) {
                //Ti.API.info('ID: ' + value + ' will get color: ' + colors[index]);
            });
            return;
        }
            
		ids.forEach(function (value, index, ar) {
			$("html").find('svg').find('[id="'+value+'"]').css("fill", colors[index]);
            $("html").find('svg').find('[id="'+value+'"]').attr("Layer", 'PitSVG-Coloring');
		});
		
		$('#coloringoff').show();
	},
	
	insertTexts:function(ids, texts, scale, xy, textstyle) {
        textstyle = typeof textstyle !== 'undefined' ? textstyle : 'Arial';
		var s = Snap('#viewer svg');
		ids.forEach(function (value, index, ar) {
			//var text = '<text style="font-family:'+ textstyle +'" x="'+ xy[index]['x'] +'" y="'+ xy[index]['y'] +'" font-size="'+ scale[index]+'">' + texts[index] + '</text>';
			//var parsed = Snap.parse(text);
            //var text = s.text(xy[index]['x'], xy[index]['y'], texts[index]);
            var text = s.multitext(xy[index]['x'], xy[index]['y'], texts[index], textstyle);
            text.attr({'font-size':scale[index] + "px"});
            text.drag();
		});
		$('#captionoff').show();
	},


	insertColoringLegend:function(name, captions, colors, scale, textstyle) {
		
        textstyle = typeof textstyle !== 'undefined' ? textstyle : 'Arial';
        scale = typeof scale !== 'undefined' ? scale : 0.9;
		
        // if no svg available - print it to console
        if($("html").find('svg').length == 0){
            //Ti.API.info('**************************  L E G E N D  **************************');
            colors.forEach(function (value, index, ar) {
                //Ti.API.info('Color: ' + value + ' ->  ' + captions[index]);
            });
            return;
        }
		
		
		$("#legend").remove();	
		$("#Canvas").append('<!-- LEGEND --><div id="legend" class="my-legend" float:"left"><div class="legend-title">The Title or Explanation of your Map</div><div class="legend-scale"><ul class="legend-labels"><!-- LEGEND goes here --></ul></div><div class="legend-source"> <button class="legend-zoomout">Verkleinern</button> <button class="legend-zoomin">Vergrößern</button> </div> </div><!-- LEGEND END -->');
			
		$('.legend-title').html(name);
        $('.legend-title').css('font-family', textstyle);
		//$('ul.legend-labels').empty();

		captions.forEach(function (value, index, ar) 
		{
            if(value != '' && colors[index] != ''){
                var li = "<li style=\"font-family: "+ textstyle+ "\"><span style='background:" + colors[index] + ";'></span>" + value + "</li>";
			$('ul.legend-labels').append(li);
            }
		});
		
        $("#legend").panzoom({
                $zoomIn: $(".legend-zoomin"),
                $zoomOut: $(".legend-zoomout"),
        });

        $("#legend").panzoom("zoom", scale);
	}
};
 

CustomSvgViewerAdapter.prototype = $.extend(
	{},
	SvgViewerLib.SvgViewerAdapter.prototype,
	CustomSvgViewerAdapter.prototype
);


var custom_vieweradapter = new CustomSvgViewerAdapter();
var custom_hostadapter = new CustomHostAdapter();

var enableButton = function(buttonID){

	var bt = $('#' + buttonID);
	if(bt.length){
	    bt.removeClass("button");
	    bt.addClass("buttonToggled");
	}
};

var disableButton = function(buttonID){

	var bt = $('#' + buttonID);
	if(bt.length){
	    bt.removeClass("buttonToggled");
	    bt.addClass("button");
    }
};

var disableMode = function(){
	if(custom_vieweradapter.record){
		custom_vieweradapter.disableRecord();
		disableButton('btRecord');
	}
	if(custom_vieweradapter.inScale){
	    custom_vieweradapter.disableZoom();
	    disableButton('btZoom');
	}
	if(custom_vieweradapter.inDraw){
		custom_vieweradapter.disableDraw();
		disableButton('btDraw');
	}
	if(custom_vieweradapter.inPin){
		custom_vieweradapter.disablePin();
		disableButton('btPin');
	}
};


function listenerFunc(e){
    	
	if(!e){
	    return;
	}
	
	if(e.msg){
		switch(e.msg){
		    case 'init': 
		    	showSVG(e.data);
		       	break;
	    }
	    return;
	}

	if(e.mode){
		switch(e.mode){
		    case 1://'enableZoom': 
		    	disableMode();
	    		custom_vieweradapter.enableZoom();
		       break;
		    case 2://'enableDraw': 
		    	disableMode();
	    		custom_vieweradapter.enableDraw();
		       break;
		    case 3:// 'enablePin': 
		    	disableMode();
	    		custom_vieweradapter.enablePin();
		       break;
		    case 4://'enableRecord': 
		    	disableMode();
		    	custom_vieweradapter.enableRecord();
		       break;
	    }
	
	    enableButton(e.id);
	}
};



function getCustomElements(){
	
	var customDrawGroup = $('#custom_draw_group');
	if(!customDrawGroup.length || customDrawGroup.children().length == 0){
		return null;
	}
	var customDrawGroupNative = customDrawGroup[0];
    var xmlConverter = new UTIL.XML.ObjTree();
    try {
        var customSVG = xmlConverter.parseDOM(customDrawGroupNative);
        return JSON.stringify(customSVG);
    
    } catch (e) {

        //Ti.App.log('Error in getCustomElements: ' + e.message);
    }
    return null;
};

function setCustomElements(customSVG){
	Ti.API.info(customSVG);
};


$(function(){
    $.contextMenu({
        selector: '.hasMenu', 
        trigger: 'none',
        callback: function(key, options) {
        	
        	var callFunction = 'on' + key;
			if(custom_vieweradapter[callFunction]){
				custom_vieweradapter[callFunction](options.$trigger);
			}
            //var m = "clicked: " + key;
            //window.console && console.log(m) || alert(m); 
        },
        items: {
            //"edit": {name: "Edit", icon: "edit"},
            //"cut": {name: "Cut", icon: "cut"},
            //"copy": {name: "Copy", icon: "copy"},
            //"paste": {name: "Paste", icon: "paste"},
            "Delete": {name: "Delete", icon: "delete"},
            //"sep1": "---------",
            //"quit": {name: "Quit", icon: function($element, key, item){ return 'context-menu-icon context-menu-icon-quit'; }}
        }
    });
});

function unRegisterEvent(){
	//Ti.API.info('unRegister svgView');
	Ti.App.removeEventListener("app:forSVG", listenerFunc);
};


$( document ).ready(function() {
	Ti.App.addEventListener("app:forSVG", listenerFunc);
    
    /*
	$(document).on('touchend', "path, polygon, circle" ,function(e){
		
		e.preventDefault();
	    //e.stopPropagation();
	
		if(!custom_vieweradapter.inPin){
			var clickedElem = $(this);
			
			var classString = clickedElem.attr('class');
			if(classString && classString.indexOf('pinCircle') >= 0){
					
				clickedElem.contextMenu();	
				return;
			}
		}
	
	
		if(custom_vieweradapter.record === true){
			
			custom_vieweradapter.selected_elements.push(this.id);
			$(this).attr( "fill", "#0F0");
			$(this).css("fill", "#0F0");
		}
	});
	*/
		
	
});

/*
//SNAP Plugin to add mulitline Texts
Snap.plugin(function (Snap, Element, Paper, glob) {
    Paper.prototype.multitext = function (x, y, txt, textstyle) {
        txt = txt.split("\n");
        var t = this.paper.text(x, y, txt);
        t.attr({"font-family": textstyle});
        t.selectAll("tspan:nth-child(n+2)").attr({
            dy: "1.2em",
            x: x,
        });

        t.selectAll("tspan").attr({
            'font-family': textstyle
        });
        return t;
    };
});
*/